
CoCoALib - Feature #356

IsZeroDivisor

24 May 2013 16:57 - John Abbott

Status: Closed Start date: 24 May 2013

Priority: Normal Due date:  

Assignee: Anna Maria Bigatti % Done: 100%

Category: New Function Estimated time: 4.00 hours

Target version: CoCoALib-0.99533 Easter14 Spent time: 3.75 hours

Description

Add new fn IsZeroDivisor for ringelem

Related issues:

Related to CoCoALib - Bug #355: Colon of zero ideal fails (zero-divisors) Closed 24 May 2013

Related to CoCoA-5 - Feature #362: New function: IsZeroDivisor Closed 29 May 2013

Related to CoCoALib - Design #429: factorization: public data fields, or mem ... Closed 28 Jan 2014

Related to CoCoALib - Design #498: IsIntegralDomain, IamIntegralDomain3 Closed 28 Mar 2014

History

#1 - 29 May 2013 19:11 - Anna Maria Bigatti

- Category set to New Function

- Status changed from New to Resolved

- Assignee set to Anna Maria Bigatti

- Target version set to CoCoALib-0.99534 Seoul14

- % Done changed from 0 to 50

First implementation done, can be improved with "IsIntegralDomain3"

#2 - 29 Oct 2013 14:48 - Anna Maria Bigatti

- Status changed from Resolved to Closed

- Target version changed from CoCoALib-0.99534 Seoul14 to CoCoALib-0.99532

- % Done changed from 50 to 100

------<  example  >------

/**/  Use P ::= QQ[x,y,z];

/**/  R := NewQuotientRing(P, ideal(x*y));

/**/  IsZeroDivisor(RingElem(R,x));

true

/**/  colon(ideal(zero(R)), ideal(RingElem(R,x)));

ideal((y))

------< end example >------

#3 - 29 Oct 2013 14:48 - Anna Maria Bigatti

- Target version changed from CoCoALib-0.99532 to CoCoALib-0.99531
#4 - 25 Mar 2014 18:10 - John Abbott

- Status changed from Closed to Resolved

- Target version changed from CoCoALib-0.99531 to CoCoALib-0.99532

- % Done changed from 100 to 90

#5 - 02 Apr 2014 17:23 - John Abbott

- Target version changed from CoCoALib-0.99532 to CoCoALib-0.99533 Easter14

#6 - 02 Apr 2014 18:01 - John Abbott

Anna's global impl is fine as a general case, but it does not offer the possibility for smarter impls when we can (e.g. in ZZ/(N) it is enough to compute

a gcd -- I suppose that's what colon would do anyway).

JAA thinks it may be appropriate to add a new mem fn to RingBase called myIsZeroDivisor; the default impl in RingBase would calculate the colon,

but some rings can impl their own "smarter" versions.

e.g. if the ring is (obviously) an integral domain, it's enough to call IsZero.

#7 - 15 Apr 2014 14:23 - John Abbott

- Status changed from Resolved to Closed

- % Done changed from 90 to 100

The current impl is simple, compact and works fine in the cases we have tried.  Let's KISS until someone points out that there is a problem.  Indeed

the case-specific "smarts" should probably be inside the relevant "colon" impl rather than just in a myIsZeroDivisor fn.

#8 - 17 Apr 2014 09:23 - Anna Maria Bigatti

- Estimated time set to 4.00 h
